﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
#Event: SelectedChanged(MIText As String,Selected As Boolean)
#Event: Action(MI As MenuItem)
Sub Class_Globals
	Private fx As JFX
	Private FM As Form
	Private mModule As Object
	Private mEventName As String
	Private CM As ContextMenu
	Type MenuItemType(MType As String,Text As String)
	Type MenuSubMenuType(Title As String, SubMenu As List)
	Private SubMenus As List
	Private CSU As CallSubUtils
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Module As Object,EventName As String)
	mModule = Module
	mEventName = EventName
	SubMenus.Initialize
	
	'Create a placeholder pane so we can set the context menu next to it
	FM.Initialize("FM",1,1)
	
	'Add an external stylesheet to the Form's Scene
	Utils.AsJO(FM.RootPane).RunMethodJO("getScene",Null).RunMethodJO("getStylesheets",Null).RunMethod("add",Array(File.GetUri(File.DirAssets,"cmenu.css")))
	
	'No control buttons on the form
	FM.SetFormStyle("UNDECORATED")
	Utils.AsJO(FM).GetFieldJO("stage").RunMethodJO("setAlwaysOnTop",Array(True))
	
	CM.Initialize("CM")
	
	'Add a style to the Context Menu
	Utils.AsJO(CM).RunMethodJO("getStyleClass",Null).RunMethod("add",Array("cmenu"))
	
	CSU.Initialize
End Sub

'Add text items to the context menu, as an array, Pass a '-' to add a seperator
'<code>FM.AddItems(Array As String("Test","-","Test1"))</code>
Sub AddItems(Items As List,Clear As Boolean)
	
	If Clear Then 
		CM.MenuItems.Clear
		SubMenus.Clear
	End If
	
	BuildContextMenu (Items)

End Sub

'Build TopLevel ContextMenu
Private Sub BuildContextMenu (Items As List)
	'Populate the context menu
	For Each It As Object In Items
		If It Is MenuSubMenuType Then
			Dim SMT As MenuSubMenuType = It
			CM.MenuItems.Add(BuildSubMenu(SMT.Title,SMT.SubMenu))
		Else IF It Is MenuCheckBoxClass Then
			Dim MCB As MenuCheckBoxClass = It
			CM.MenuItems.Add(MCB.AsJavaObject)
		Else
			CM.MenuItems.Add(It)
		End If
	Next
	
End Sub

'Build and return a submenu
Sub BuildSubMenu(Title As String,Items As List) As Menu
	Dim M As Menu
	M.Initialize(Title,"MI")
	'Process the menu Items
	For Each It As Object In Items
		If It Is MenuSubMenuType Then
			Dim SMT As MenuSubMenuType = It
			M.MenuItems.Add(BuildSubMenu(SMT.Title,SMT.SubMenu))
		Else IF It Is MenuCheckBoxClass Then
			Dim MCB As MenuCheckBoxClass = It
			M.MenuItems.Add(MCB.AsJavaObject)
		Else
			M.MenuItems.Add(It)
		End If
	Next
	SubMenus.Add(M)
	'Add a style to the SubMenu
	Utils.AsJO(M).RunMethodJO("getStyleClass",Null).RunMethod("add",Array("cmenu"))
	Return M
End Sub

'Show the invisible dummy panel and the context menu to the right of it (will automatically reposition if it would be off the screen)
Sub Show(X As Int,Y As Int)
	HideSubMenus
	Hide
	FM.WindowLeft = X
	FM.WindowTop = Y
	FM.Show
	Utils.AsJO(CM).RunMethod("show",Array(FM.RootPane,"RIGHT",0.0,0.0))
	CSU.CallSubPlus2(Me,"RequestFocusDelayed",50,Array(CM))
End Sub

Private Sub RequestFocusDelayed(Args() As Object)						'Ignore
	Dim JO As JavaObject = Args(0)
	JO.RunMethod("requestFocus",Null)
End Sub

'Hide the invisible panel and context menu
Sub Hide
	Utils.AsJO(CM).RunMethod("hide",Null)
	FM.Close
	
End Sub
Sub HideSubMenus
	For Each SM As JavaObject In SubMenus
		SM.RunMethod("hide",Null)
	Next	
End Sub

'Menu item clicked, pass it back to the originating module
Sub MI_Action
	Hide
	Dim MI As MenuItem = Sender
	'Added for compliance with other views
	If SubExists(mModule,mEventName & "_Action") Then 
		CallSub2(mModule,mEventName & "_Action",MI)
	Else
		'Deprecated but do not remove
		If SubExists(mModule,mEventName & "_Clicked") Then CallSub2(mModule,mEventName & "_Clicked",MI)
	End If
End Sub

Sub CB_SelectedChanged(MCB As MenuCheckBoxClass)
	If SubExists(mModule,mEventName & "_SelectedChanged") Then CallSub2(mModule,mEventName & "_SelectedChanged",MCB)
End Sub



Public Sub MenuSubMenu(Title As String,SubMenu As List) As MenuSubMenuType
	Dim SM As MenuSubMenuType
	SM.Initialize
	SM.Title = Title
	SM.SubMenu = SubMenu
	Return SM
End Sub

'Create and return a SeperatorMenuItem Object
Public Sub MenuSeparator As JavaObject
	Dim JO As JavaObject
	JO.InitializeNewInstance("javafx.scene.control.SeparatorMenuItem",Null)
	'Add a style to the Separator
	JO.RunMethodJO("getStyleClass",Null).RunMethod("add",Array("cmenu"))
	Return JO
End Sub
'Create and return a TextMenuItem Object
Public Sub MenuText(Text As String,Tag As Object) As JavaObject
	Dim MI As MenuItem
	MI.Initialize(Text,"MI")
	MI.Tag = Tag
	'Add a style to the MenuItem
	Utils.AsJO(MI).RunMethodJO("getStyleClass",Null).RunMethod("add",Array("cmenu"))
	Return MI
End Sub

'Create and Return a CheckMenuItem and set a changelistener
Public Sub MenuCheckBox(Text As String,Tag As Object) As MenuCheckBoxClass
	Dim MCB As MenuCheckBoxClass
	MCB.Initialize(Me,"CB",Text)
	MCB.Tag = Tag
	'Add a style to the Checkbox Menu Item
	MCB.AsJavaObject.RunMethodJO("getStyleClass",Null).RunMethod("addAll",Array(Array As String("cmenu","cmcheckbox")))
	Return MCB
End Sub

'Create and return a MenuTitle Object
Public Sub MenuTitle(Text As String) As JavaObject
	Dim MI As MenuItem
	MI.Initialize(Text,"")
	'Add a style to the MenuItem
	Utils.AsJO(MI).RunMethodJO("getStyleClass",Null).RunMethod("add",Array("title"))
	Return MI
End Sub

Public Sub setTag(Tag As Object)
	Utils.AsJO(Me).runMethod("setUserData", Array(Tag))
End Sub

Public Sub getTag As Object
	Return Utils.AsJO(Me).runMethod("getUserData", Null)
End Sub