﻿Type=StaticCode
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private NH As NativeHook
	Private mModule As Object
	Private TH As Thread									'ignore
	Private mFM As FloatingMenu
	Private CSU As CallSubUtils
	
	'V 0.8
	Private mIgnoreClickOnWindow As Boolean		'Optional allow clicks through to the window
	Private PressIgnored As Boolean				'If the pressed event is ignored, we should ignore the released event as well
	Private mMainForm As Form
	Private OverWindow As Boolean				'Is the mouse currently over the window?
	Private MouseoverEventSet As Boolean		'Disallow setting the event listeners more than once
	
	'V0.8.5
	Private MouseListenerPaused As Boolean	

End Sub

Sub initialize(Module As Object,MainForm As Form,FM As FloatingMenu)
	mModule = Module			'Parent module
	mFM = FM					'Need to access the Floating Menu Object so we can close it if it's not clicked on.
	CSU.Initialize				'CallSubUtils
	TH.Initialise("TH")			'Initialize a Thread Object so we can pass data to the Gui Thread
	NH.Initialize("NH", Me)     'Initializes and registers the NativeHook
    NH.startNativeKeyListener   'starts a NativeKeyListener
    NH.enableKillCode   		'Allows you to manually unregister by pressing Windows_Escape
    NH.EnableEventConsumption  	'Allows you to consume input events
	NH.startNativeMouseInputListener
	
	'V0.8
	mMainForm = MainForm
	
End Sub

Private Sub setMainFormListener
	If MouseoverEventSet = False Then
		Dim JO As JavaObject = mMainForm.RootPane
		Dim Event As Object = JO.CreateEventFromUI("javafx.event.EventHandler","MFMouseOver",Null)
		JO.RunMethod("setOnMouseEntered",Array(Event))
		Event = JO.CreateEventFromUI("javafx.event.EventHandler","MFMouseOver",Null)
		JO.RunMethod("setOnMouseExited",Array(Event))
		MouseoverEventSet = True
	End If
End Sub


#Region Options
'V0.8 Set the floating menu
Public Sub setFloatingMenu(Fm As FloatingMenu)
	
	'Make sure the existing floating menu is not displayed
	mFM.HideSubMenus
	mFM.Hide
	
	'Switch Floating Menus
	mFM = Fm
	
End Sub

'V0.8 Get the floating menu
Public Sub getFloatingMenu As FloatingMenu
	Return mFM
End Sub

'V0.8 Set IgnoreClickOnWindow
Public Sub setIgnoreClickOnWindow(Ignore As Boolean)
	mIgnoreClickOnWindow = Ignore
	
	If mIgnoreClickOnWindow Then
		setMainFormListener
	End If
End Sub

'V0.8 Get IgnoreClickOnWindow
Public Sub getIgnoreClickOnWindow As Boolean
	Return mIgnoreClickOnWindow
End Sub

Public Sub IsOverWindow As Boolean
	Return OverWindow
End Sub

#End Region Options


'Sub to handle Mouse Pressed call from the Native hook
Private Sub NH_NativeMousePressed(nme As NativeMouseEvent) As Boolean
	If nme.MouseButton = 2 Then 
		If mIgnoreClickOnWindow And OverWindow Then
			PressIgnored = True
			Return False
		End If
		
		'Mouse button 2 has been pressed
		TH.RunOnGuiThread("Mouse_Clicked",Array(nme,True))
		
		'Consume the event
		Return True
	End If

	Return False
End Sub

'Sub to handle Mouse Released call from the Native hook
Private Sub NH_NativeMouseReleased(nme As NativeMouseEvent) As Boolean
	
	If nme.MouseButton = 2 Then 
		If (mIgnoreClickOnWindow And OverWindow And PressIgnored) Or PressIgnored Then 
			PressIgnored = False
			Return False
		End If
		
		'Mouse button 2 has been released
		TH.RunOnGuiThread("Mouse_Clicked",Array(nme,False))
		
		'Consume the event
		Return True
	End If

	'Need to delay this call as it can interfere with the callback from the Floating Menu if it runs too quickly
	CSU.CallSubPlus(Me,"THMFHide",250)
	
	'Do not consume the event
	Return False
End Sub

'V0.8 Record whether the mouse is currently over the window
Private Sub MFMouseOver_Event(MethodName As String,Args() As Object) As Object
	Dim Mev As JavaObject = Args(0)
	If Mev.RunMethodJO("getEventType",Null).RunMethod("getName",Null) = "MOUSE_ENTERED" Then
		OverWindow = True
	Else
		OverWindow = False
	End If
	Return False
End Sub

'
#Region 'Gui call Subs
'Need an intermediate sub as it is called from a seperate Thread
Private Sub Mouse_Clicked(nme As NativeMouseEvent, Pressed As Boolean)
	mFM.HideSubMenus
	If Pressed Then mFM.Show(nme.X,nme.Y)
	If SubExists(mModule,"Mouse2_Clicked") Then CallSub3(mModule,"Mouse2_Clicked",nme, Pressed) 'ignore
End Sub

'Need an intermediate sub as it is called from a seperate Thread
Private Sub mFMHide As Boolean																	'ignore
	mFM.hide
	Return False
End Sub

'Need a second intermediate sub as it is called from a seperate Thread and delayed
Private Sub THMFHide																			'ignore
	TH.RunOnGuiThread("mFMHide",Null)
End Sub
'
#End Region
'

'Event fired whenever a key is pressed, regardless of what application is in focus
Private Sub NH_NativeKeyPressed(nke As NativeKeyEvent) As Boolean
    If NH.isCharacter(nke.keyCode) Then
        Log(nke.keyText & " Pressed")
		'Not needed for the mouse example
'        If nke.keyText=="F" Then Return True    'Consumes the event if the user pressed the "F" key
    End If
    Return False
End Sub


'V0.8.5 Allow pausing Mouseinput Listener
Public Sub Pause
	NH.endNativeMouseInputListener
	MouseListenerPaused = True
End Sub

''V0.8.5 Allow restarting the Mouseinput Listener after it's been paused
Public Sub ReStart
	If MouseListenerPaused Then
		NH.startNativeMouseInputListener
		MouseListenerPaused = False
	End If
End Sub

'Allow stopping listeners
Public Sub Stop
	NH.endNativeMouseInputListener
	NH.unregisterNativeHook
End Sub

'Event fired when the NativeHook is unregistered
'Sub needs to be here or an error is thrown by the library, it is used will depend on the application.
'This application only unregisters the listener when it closes so we don't need to do anything.
Private Sub NH_Unregistered
    Log("NativeHook unregistered")
'	ExitApplication
End Sub
